import type { Module, Submodule } from "../../module.ts";
import type { type } from "../ark.ts";
import type { Branded, constrain, To } from "../ast.ts";
declare namespace string {
    type normalized = normalized.NFC;
    namespace normalized {
        type NFC = constrain<string, Branded<"normalized.NFC">>;
        type NFD = constrain<string, Branded<"normalized.NFD">>;
        type NFKC = constrain<string, Branded<"normalized.NFKC">>;
        type NFKD = constrain<string, Branded<"normalized.NFKD">>;
    }
}
export declare const normalizedForms: readonly ["NFC", "NFD", "NFKC", "NFKD"];
export type NormalizedForm = (typeof normalizedForms)[number];
export declare const NFC: Module<{
    $root: object;
    preformatted: object;
}>;
export declare const NFD: Module<{
    $root: object;
    preformatted: object;
}>;
export declare const NFKC: Module<{
    $root: object;
    preformatted: object;
}>;
export declare const NFKD: Module<{
    $root: object;
    preformatted: object;
}>;
export declare const normalize: Module<{
    $root: object;
    NFC: Submodule<{
        $root: object;
        preformatted: object;
    }>;
    NFD: Submodule<{
        $root: object;
        preformatted: object;
    }>;
    NFKC: Submodule<{
        $root: object;
        preformatted: object;
    }>;
    NFKD: Submodule<{
        $root: object;
        preformatted: object;
    }>;
}>;
export declare namespace normalize {
    type module = Module<submodule>;
    type submodule = Submodule<$>;
    type $ = {
        $root: (In: string) => To<string.normalized.NFC>;
        NFC: NFC.submodule;
        NFD: NFD.submodule;
        NFKC: NFKC.submodule;
        NFKD: NFKD.submodule;
    };
    type shallowResolutions = {
        [k in keyof $ as `string.normalize.${k}`]: $[k] extends type.cast<infer t> ? t : $[k];
    };
    namespace NFC {
        type submodule = Submodule<$>;
        type $ = {
            $root: (In: string) => To<string.normalized.NFC>;
            preformatted: string.normalized.NFC;
        };
    }
    namespace NFD {
        type submodule = Submodule<$>;
        type $ = {
            $root: (In: string) => To<string.normalized.NFD>;
            preformatted: string.normalized.NFD;
        };
    }
    namespace NFKC {
        type submodule = Submodule<$>;
        type $ = {
            $root: (In: string) => To<string.normalized.NFKC>;
            preformatted: string.normalized.NFKC;
        };
    }
    namespace NFKD {
        type submodule = Submodule<$>;
        type $ = {
            $root: (In: string) => To<string.normalized.NFKD>;
            preformatted: string.normalized.NFKD;
        };
    }
}
export {};
